/*
 *
 * V0.C         Main program for the editor.
 *
 */

#define KEYDEFS 1               /* include key defs from v.h            */
#include "v.h"                  /* Program-wide definitions             */

main(argc,argv) int argc; char **argv; {
int i,ii,iii,NN; int n;
LLONG lx,ly;
int x,mainMACRO,maclevel;
int flg,fiddle,wasENTERKEY;
int killcurfile;
int repeatflag;
int cmd,freeze;
char *doGOTO;
unsigned c=0;
unsigned xc;
char **q;
char *p;
char *sob(),*core(),*strchr();
extern LLONG poplines();
extern LLONG pushlines();
extern LLONG atoiLL();
extern LLONG getoffset();
extern LLONG absLL();
extern char *lltoa();
unsigned menu();
extern unsigned foreign();
extern unsigned char *curchar();
LLONG getatoiLL();      /* ==atoiLL(sysv); */
extern int regdef;
int bookcol;
LLONG bookline;
struct bigarray X;
extern char *SRCDIR;

top:
  setup();                      /* TURBOC setup() sets screen black. */
  if(bufbase == NULLP) {        /* Only do this loop on first entry */
    progname=argv[0];           /* Program name on startup */
#if PIINILOAD                   /* These functions use core()! */
    loadinifile(argc,argv);     /* All dimensions set here. */
    loadtcap(argc,argv);        /* load termcap info. may quit(1). */
#endif
    /* Most variables below are set in PI.RC (~/.PIrc for Unix). */
    insmode = INSMD;
    if(COLMAX>=MAXLN) MAXLN=COLMAX+10;
    if(ROWMAX>=MAXROWS) MAXROWS=ROWMAX+1;
    NN=1+MAXLN;
    iii=max(NN,MAXFN);
    HEADROOM=NN+NN+(SIZEBLOCK=1024*SIZEKBLOCK);
    LINESIZE=MAXROWS*sizeof(char *);
    SCRSIZE=max(NN*MAXROWS,HEADROOM);
    FARSCROLL=1+ROWMAX;                         /* must be > ROWMAX */
    bookline=bookcol=
    repeatflag=maclevel=flg=fiddle=tabstop=macmax=mainMACRO=0;
    XMSinit();  /* MSDOS: Changes MAXBLOCK, sets up handles[] */
    getcorememblock();
    line = (char **)core(LINESIZE); /* screen line pointers */
    scrbuf = core(SCRSIZE);             /* screen buffer SCRSIZE */
    optbuf = core(NN);                  /* phrase buffer */
    getkillercore();                    /* Killed line buffer alloc */
    macrobuf=(char **)core((MACNUM+1)*sizeof(char *));
    macromax=(int *)core((MACNUM+1)*sizeof(int));
    for(i=0;i<MAXROWS;++i) {line[i]= (char *)&scrbuf[i*NN]; }
    macbuf = macrobuf[0]                /* macro recording buffer */
           = core(MAXMB);
    sysv   = core(iii);                 /* system scratch */
    sysx   = core(iii);                 /* system scratch */
    sysvv  = core(iii);                 /* system scratch */
    srcharg = core(NN);                 /* last search argument */
    lastarg = core(NN);                 /* last getstr argument */
    replarg = core(NN);                 /* last replace argument */
    sysfile = core(MAXFN);              /* system file name, 128 */
    cd = core(CDSIZE);                  /* conn dir name, 128-1024 */
    i =3*HEADROOM;                      /* size of work buffer */
    bufbase = core(i);                  /* work buffer base */
    hbuf = ebuf = bufbase-1+i;
    *bufbase++ = EOS;                   /* guard byte for nonzero searches */
    *cd = *bufbase = *(lbuf=bufbase-1) = EOS;
    initfinfo();                        /* Initialize finfo[] array */
    corefinfo(0,NOTEPAD);
    setfile(0); finfo[0].active=1;
#if MATHFLOAT
    safecore(&MATHFMT,"%.08g");
#endif
#if PIINILOAD
    loadkeys(argc,argv);                /* Load key definitions and sort! */
#endif
#if !MSDOS
    setdrawbuff();                      /* Set up buffer for drawing screen */
#endif
    sorttable();                        /* sort the key table! */
    getSHELL();                         /* Determine shell variable */
  }                                     /* end of setup routine */
 /* process command line options */
#if PIINILOAD
  initterminal();               /* set application pad (loadini data) */
                                /* Clear the screen (loadini data) */
  clrcon(); macabort();         /* clear type-aheads & buffer */
#endif
  stylechange(drawstyle);
#if BSDunix || SYS5
  freeze=0;
#endif
  if(argc>1) drawall();
  for(doGOTO=0,cmd=1;cmd<argc;cmd++){
    strcpy(sysv,argv[cmd]);
#if BSDunix || SYS5
    if(sysv[0]=='-'){                   /* command line goto line # */
      if(sysv[1]=='x') freeze=1;        /* freeze exits for xterm window */
      if(sysv[1]=='m')                 /* Use unix mouse with xterm */
        {mouseswitch=1; setmouse(1);}
    }
#endif
    flg = (cmd != argc-1);
    if(flg && *(p=argv[cmd+1])=='-' && p[1]=='g') doGOTO=p+2;
    if(sysv[0]!='-' && isinfo(sysv)==0) goto doload;
cmdline: ;
  }
  copydefaultfile();
  flg=0;
  if(usedfiles()==1) {
    if(ACTIONSTART) {drawall(); c=MENUKEY; lcount(); goto popupmenu;}
    goto loadnewfile;
  }
  drawall();
  while(TRUE) {
loop:
#if BSDunix || SYS5          /* Window size change detected */
      if(doWinUpdate()) goto winupdate;
#endif
    lastkey=c;
    i = macrun;
    wasENTERKEY=0;
#if BSDunix || SYS5          /* Window size change detected */
    if(PIPEopen) c=getpipe();
    else
#endif
    if((c = getkey()) == ENTERKEY) {wasENTERKEY=1; c=entkey();}
popupmenu:
    closehelpsheet();
    if(c==MENUKEY) {c=menu(); wasENTERKEY=0; curses();}
    if(repeatflag){ repeats=repeatflag; repeatflag=0; repkey=c;}
    if(c == COMPLETEKEY){ c=NULLKEY; HelpKeys(&c); goto popupmenu;}
    testdraw();
    if(!macrun && i) lcount();
/* Regular characters change buffer text */
    if((0xFF00 & c) == 0) goto editor;
    /* this changes buffer text, then goes on to do cursor motion */
    if(drawline){
      iii=insmode;
      insmode=0;
      i=row; ii=col;
      if((x=boxdraw(c)) != 0){
        editln(x); fiddle=1; row=i; col=ii;
        if(col==COLMAX) --col;
      }
      insmode=iii;
    } /* now go do the cursor motion */

/* Is it a macro key? */
    i=c-MACROKEY; if(1<=i && i<= MACNUM) goto macroexec;

/* First try keys that don't change the buffer text */
/* These all accept a repeat count but may not optimize. */
    switch(c) {
#if BSDunix || SYS5
    case SETMOUSE:  /* Enable unix mouse */
               mouseswitch=1;
               setmouse(1); goto newcursor;
    case UNSETMOUSE: /* Disable unix mouse */
               mouseswitch=0;
               setmouse(0); goto newcursor;
    case MOUSEPRESS: /* Mouse event */
               pressmouse();
               goto newcursor;
    case MOUSERELEASEVALID: /* Valid mouse release */
               releasemouse('t'); goto newcursor;
    case MOUSERELEASEINVALID: /* Invalid mouse release */
               releasemouse('T'); goto newcursor;
#endif
#if MSDOS && DOS386I
    case MOUSEPRESS: /* Mouse event */
               pressmouse();
               goto newcursor;
#endif
    case OPTMATH:            /* Replace optbuf[] by math answer */
         convert2int(optbuf);
         goto newcursor;
      case OPTHEX:
        hexstrToBase10str(optbuf);
        goto newcursor;
      case OPTOCT:
        octstrToBase10str(optbuf);
        goto newcursor;
#if MATHFLOAT
    case OPTMATHFLOAT:  /* optbuf[] replaced by float math answer */
         convert2double(optbuf);
         goto newcursor;
    case OPTEVALEXPR:  /* Convert via expression eval */
         calculator(optbuf);
         goto newcursor;
    case MATHFORMAT:    /* Set sprintf format for float math answer */
         setmathformat();
         goto newcursor;
#endif
    case RECORDING:
recording:
         macabort();
         maclevel=macromax[mainMACRO=0]=nodisp=macmax=0;
         macbuf=macrobuf[mainMACRO];          /* set new macro */
         recordbanner();                /* set record=1, print message*/
         goto justcurses;
    case RUNMEMORIZE:                   /* Run macro */
         if(macrep>1) goto exitmacro;   /* ignore key in running macro */
         if(macrun || !wasENTERKEY)     /* poplevel or stop */
           goto runmem;
    case MANYRUNMEM:                    /* start recording or mult macro */
         if(!wasENTERKEY){
           sysarg=0;
           getnumquery("Repeat how many? ",&sysarg,0,-1);
           if(sysarg) repeats=sysarg; else goto newcursor;
         }
         if(!sysarg) goto recording;
runmem:
         if(maclevel) {                 /* deep recursion */
           setlevel(--maclevel,0);      /* pop level */
           goto exitmacro;
         }
         if(record) goto offrecording;  /* signal to quit recording */
         if(macrun) goto exitmacro;     /* ignore key in running macro */
         i=mainMACRO;
setmacro:                               /* do next macro on macrobuf[i] */
         macrun = 1;                    /* macro running */
         macind = 0;                    /* set start of buffer */
         macbuf=macrobuf[i];            /* set new buffer address */
         macmax=macromax[i];            /* set new buffer count */
         macrep=repeats;
         if(wasENTERKEY) {              /* Repeat count entered */
           if(sysarg<0) nodisp = 1;     /* Negative? Display off */
           macrep=abs(sysarg);          /* Set macro repeat count */
         }
         if(macrep<=0) macrep=1;        /* don't use bad repeat count */
         repeats=1;                     /* No one else gets repeats */
exitmacro:
         goto justcurses;
offrecording:
         /* Recording off by some key sequence but we don't know */
         /* the length of the key sequence. So we have to include */
         /* in the macro the termination sequence. */
         /* User macros can remove the extra characters. */
         macromax[mainMACRO=0]=macmax;
         macabort();
         maclevel=nodisp=0;             /* Display on, stack restored */
         banner("Stopped Recording");
         lnumcount();
         goto justcurses;
    /* Select and run a given macro */
macroexec:
         if(macromax[i]==0) break;      /* nothing to do */
         if((record && mainMACRO==i) || /* simple recursion detected */
            (maclevel>=10)){            /* deep recursion detected */
             macmax=0;
             goto offrecording;
         }
         if(macrun || record)           /* if key from a macro, then */
           setlevel(maclevel++,1);      /* push parameters */
         macabort();
         goto setmacro;
    case BACKTOGGLE:
         /* 0=FALSE,1=$HOME/PIbackups,2=./PIbackups */
         setbackups();
         goto justcurses;
    default: goto secondswitch;           /* key not found in list */
    }                                   /* end switch(c) */
    continue;

secondswitch:

    if(wasENTERKEY) c += WASENTER;      /* Mark enter key sequences */

    switch(c){
    case NEWSEARCH+WASENTER:            /* setup search string */
    case NEWSEARCH:                     /* setup search string */
         {char *msg[]={
           "Enter a search string.",
           "Then press:",
           "",
           " RET  Save string",
           " F5   Search forward",
           " F6   Search backward",
           "",
           "Recall string history",
           "with UpArrow, DnArrow.",
           "",
           "Shift-Ctrl-@ matches begin",
           "line or end line. Two of",
           "them match a blank line.",
           0};
           WarningMessage(msg); /* memory released; erase screen later */
           /* closehelpsheet(); */  /* Clean up the screen */
         }
         c=getquery("Search for: ");
         closehelpsheet();
         switch(c){
         case RETURNKEY: if(sysv[0]) banner("Search string saved");
         case FWDSEARCH:
         case REVSEARCH: if(sysv[0]) copysrcharg(sysv);
                         if(c!=RETURNKEY) break;
         default: goto justcurses;
         }
    }

/* Character c wasn't harmless. Do next set which might change text. */
    switch(c){
    case TABKEY:                        /* TAB key ctrl-I */
           i = TSTOPS - ((col+curoff) % TSTOPS);
           if(TABINSERT){
             if(!DETABBER){editln('\t'); goto newcursor;}
             if(strlen(line[row])+i>=MAXLN-1){bell(); goto newcursor;}
             fillchr(sysx,' ',i); sysx[i]=0;
             addstring(sysx,line[row],1,1);
           }
           col = min(COLMAX,i+col);
           goto newcursor;
    case TABKEY+WASENTER:
    case REVTABKEY:                     /* reverse tab */
         if((i = ((col+curoff) % TSTOPS)) == 0) i = TSTOPS;
         if(TABINSERT){                 /* reverse hacking tab */
           while(i && curchar()[-1]==' ') { editln(127); fiddle=1; --i; }
         }
         col = max(0,col-i);
         goto newcursor;
    case WORDAHEAD:                    /* cursor to next word */
         nextword(0); goto newcursor;
    case WORDBACK:                     /* cursor to previous word */
         prevword(); goto newcursor;
    case UPARROW:                       /* cursor up */
         edup();
         goto newcursor;
    case DOWNARROW:                     /* cursor down */
         eddn();
         goto newcursor;
    case RIGHTARROW:                    /* cursor forward */
         edright(); goto newcursor;
    case LEFTARROW:                     /* cursor backward */
         edleft(); goto newcursor;
    case PAGEFORWARD:                   /* Page forward */
         setSYSone();                   /* copy "1" to sysv[] array */
    case PAGEFORWARD+WASENTER:          /* Enter+Page forward */
         if(sysv[0]==0) goto endoffile;
         Prefreshh(1);                  /* refresh, same cursor */
         goto newcursor;
    case CENTERREFRESH:                 /* Cursor at center, refresh */
         sysv[0]=0;
    case LINEFORWARD+WASENTER:          /* Enter+Line forward */
         Crefreshh(getatoiLL());       /* refresh, cursor center */
         goto newcursor;
    case LINEFORWARD:                   /* Line forward */
         linedn();
         if(row) decrROW();
         goto newcursor;
    case PAGEBACK:                      /* Page backward */
         setSYSone();
    case PAGEBACK+WASENTER:             /* Enter+Page backward */
         if(sysv[0]==0){ topfile(); goto newcursor;}
         Prefreshh(-1);                 /* refresh, same cursor */
         goto newcursor;
    case LINEBACK+WASENTER:             /* Enter+Line backward */
         Crefreshh(-getatoiLL());       /* refresh, cursor center */
         goto newcursor;
    case LINEBACK:                      /* Line backward */
         lineup();
         if(row<ROWMAX) incrROW();
         goto newcursor;
    case EMACSRETURNKEY:
emacsReturnkey:
         i=divide(); homeit(); col=i; eddn(); goto markchanged;
    case RETURNKEY:                     /* carriage return */
         if(insmode && EMACSMODE) goto emacsReturnkey;
         homeit(); eddn();
         /* Maybe indent to previous line if current line is blank. */
         /* Arrive here with row>0 and col==0. */
         if(HangingIndent && INDENAUTO && !line[row][0]){
           while(line[row-1][col] == ' ') ++col;
         }
         goto newcursor;
    case SPLITLINE:                     /* split line at cursor */
         divide(); goto markchanged;
    case INSERTLINE:                    /* insert line */
         addln("",TRUE); goto markchanged;
    case DELLINE:                       /* delete line */
         if(addtolist(line[row],secondkill(),1)){delln(sysv); goto markchanged;}
         goto justcurses;
    case DELLINE+WASENTER:              /* Enter+delete line */
massdel2:
         n=1;
massdel:
         lx=getatoiLL();
massdel1:
         if(massdelete(n,lx)) goto markchanged;
         goto newcursor;
    case ERASELINE:                     /* Erase but don't join lines */
         if(*curchar()==0) goto newcursor;
    case ERASEKEY+WASENTER:             /* Enter+erase to end of line */
         col = 0; curses();             /* erase whole line */
    case ERASEKEY:                      /* erase to end of line */
         killline();
         goto markchanged;
    case ADDBUFFER:
         setSYSone();
    case ADDBUFFER+WASENTER:
         goto massdel2;
    case DELCHAR:                       /* delete char */
         editln(0); goto textchanged;
    case WORDERASE:     /* erase word at cursor */
         if(nextword(1)) goto markchanged;
         goto newcursor;
    case PUSHKEY:                       /* Copy line to killerlist */
         if(addtolist(line[row],secondpush(),1)){
           eddn(); goto newcursor;
         }
         goto justcurses;
    case SETBUFFER:
         sysv[0]=0;
         if(FindFile(sysv,sysv,1)==0) goto newcursor;
         i=sysarg;
         goto setnextbuffer;
    case PREVEDIT:
         sysarg=1;
    case PREVEDIT+WASENTER:
         sysarg= -abs(sysarg);
         goto nextbuffer;
    case NEXTEDIT+WASENTER:             /* Edit next file in finfo[] chain */
         if(sysarg==0) sysarg = -1;
         goto nextbuffer;
    case NEXTEDIT:                      /* Edit next file in finfo[] chain */
         if(flg) goto cmdline;
         sysarg=1;
         goto nextbuffer;
    case REFORMKEY:                     /* reform line */
         reform(); goto markchanged;
    case CENTERTEXT:
         textcenter(); goto textchanged;/* center text on line */
    case CASELOWER:                     /* cursor char to lower case */
    case CASELLOWER:                    /* convert word to lower case */
    case CASEUPPER:                     /* cursor char to upper case */
    case CASELUPPER:                    /* convert word to upper case */
    case CASECAPITAL:                   /* capitalize word */
changecase:
         if(casechange(c)) goto textchanged;
         goto newcursor;
    case ZEROTOKEN:     /* Insert ZERO token for begin/end line */
        editln(zero); goto textchanged;
    case LFWDSEARCH+WASENTER:           /* Line Search forward */
    case LFWDSEARCH:                    /* Line Search forward */
         ii=3; goto searching;
    case LREVSEARCH+WASENTER:           /* Line Reverse search */
    case LREVSEARCH:                    /* Line Reverse search */
         ii=4; goto searching;
    case FWDSEARCH+WASENTER:            /* Search forward */
    case FWDSEARCH:                     /* Search forward */
         ii=1; goto searching;
    case REVSEARCH+WASENTER:            /* Reverse search */
    case REVSEARCH:                     /* Reverse search */
         ii=2; goto searching;
searching:
         if(wasENTERKEY) copysrcharg(sysv);
         if(!search(ii)) { macabort(); testdraw(); }
         /* Trick to load next key and erase highlighting */
         else {repkey=getkey(); ++repeats; unshowmatch();}
         goto justcurses;
    case QUERYREPLACE:
         if(queryreplace(insmode)) goto textchanged;
         goto newcursor;
    }/* end switch */


thirdswitch:
    if(!macrun) repeats=1;              /* Other commands can't use */
    switch(c){                          /* a repeat count at all */
    case GRABTEXT:                      /* copy screen text to status read */
         editln(127);                   /* or delete char left */
         goto textchanged;
    case SETBOOKMARK:                   /* Set bookmark line no. */
       bookline=lncount; bookcol=col;
       banner("Bookmark set");
       goto newcursor;
    case GOBOOKMARK:                    /* Goto bookmark line no. */
/* lncount problems */
       lx=bookline; col=bookcol; goto gotokey1;
    case GOTOKEY:                       /* ctrl-OG goto line # */
       getquery("GOTO line number: ");
    case GOTOKEY+WASENTER:              /* Enter+ctrl-OG goto line # */
gotokey:
        lx=getatoiLL();
gotokey1:
         ly=lx-lncount;
         if(lx>0 && ly) Crefreshh(ly);
         goto newcursor;
    case LINEDRAWKEY:                   /* ctrl-OL Toggle box/line draw*/
         stylechange(0);                /* ctrl-OL Set box/line style */
         goto newcursor;
    case HOMEKEY:                       /* cursor home */
         lncount -= row;
         row = col = 0; goto newcursor;
    case REVHOMEKEY:                   /* Cursor to screen bottom */
         lncount += (ROWMAX-row);
         col = 0; row = ROWMAX; goto newcursor;
    case FILETOP:                       /* Top of file */
         topfile(); break;
    case FILETOP+WASENTER:              /* Enter+Top of file */
    case FILEBOTTOM:                    /* keypad enter + function key f3 */
endoffile:
         eofile();
         endit();
         goto newcursor;
    case INSMODE:                       /* Insert mode toggle */
         settoggle("Insert",&insmode);
         goto justcurses;
    case QPUSHKEY:                      /* copy sysv to phrase buffer */
         getquery("Fill phrase: ");
         strcpy(optbuf,sysv);
         goto newcursor;
    case EXTRIGHTARROW:                 /* Cursor to right edge */
         endit();
         goto newcursor;
    case EXTLEFTARROW:                  /* Cursor to left edge */
         homeit();
         goto newcursor;
    case NAMECHANGE:                    /* change name of current file */
         if(curfile==0) break;          /* can't change notepad */
         if(getfname("New name: ",sysv) && !exists(sysv)) {
           if(corefinfo(curfile,sysv)) strcpy(sysfile,sysv);
         }
         goto newcursor;
    case SETTEXTTYPE:                   /* set In/Out Text Type */
         setinputoutput();
         goto newcursor;
    case SETTABS:
         settabs();
         goto newcursor;
    case ASCIITABLE:
         /* 0=off, 1=full, 2=file only, 3=ascii table */
         DOSTATUS = (DOSTATUS==3) ? 1:3;
         goto newcursor;
    case SETSTATUS:                     /* toggle status line on/off */
         /* 0=off, 1=full, 2=file only, 3=ascii table */
         if(++DOSTATUS > 3) DOSTATUS=0;
         goto newcursor;
    case SETAUTO:                       /* toggle auto-indent mode */
         settoggle("Indent",&INDENAUTO);
         goto justcurses;
    case SETHANGING:                    /* toggle hanging-indent mode */
         settoggle("Hanging indent",&HangingIndent);
         goto justcurses;
    case WORDWRAP:                      /* toggle word wrap mode */
         settoggle("Word wrap",&WRDWRP);
         goto justcurses;
    case SETDETAB:                      /* toggle auto-detab forward scroll */
         setdetab();
         goto newcursor;
    case SETBLANKSTRIP:                 /* Toggle strip of trailing spaces */
         settoggle("Stripping", &BLANKSTRIP);
         goto justcurses;
    case SETSTRIP:                      /* toggle strip parity bits */
         settoggle("High strip",&BITSTRIP);
         goto justcurses;
    case OPTIONSET:
         options(); goto redraw;
    case FOLDSRCH:
         settoggle("Fold case",&FOLDCASE);
         goto justcurses;
    case MACROKEY:
         macabort(); mainMACRO=maclevel=0;
         macmax=macromax[0]; macbuf=macrobuf[0];
         copymacro();
         goto newcursor;
    case SWAPMARK:
         if(markset) {
           swapmarker();
           if(lastkey!=SWAPMARK) goto justcurses;
           if(col+curoff>=markcol && lncount>=markline) goto reveal;
           goto revealmark;
         }
         goto reveal;
    case SETMARK:                       /* Set mark for block operations. */
         markblock(col+curoff);
         banner("Block start. ");
         strinvvideo("Move cursor to end of block.");
         goto justcurses;
    case REVEALMARK:
revealmark:
         if(markset) setcorner();
reveal:
         if(markset){
           i=regionbanner("RETURN to exit","");
           goto newcursor;
         }
reveal1:
         badregion(); goto justcurses;
    case MENUBOXSET:
         getnumquery("Menu box character set (0=Text,1=vga1,2=vga2,3=iso1,4=iso2) ",&boxcharset,0,4);
         goto newcursor;
    case COLORSET:
         setupcolors();
         goto redraw;
#if MSDOS
    case SWAPSW:                        /* Toggle MSDOS disk swap mode */
         swapswitch=1-swapswitch;
         banner( swapswitch ? "Ralf Brown SPAWN" : "TurboC");
         goto justcurses;
    case VIDEOMODE:
         i=x= getvideomode();
         getnumquery("Mode (0-3,7,80-90)",&x,0,100);
         if(x!=i) setvideomode(x);
         goto redraw;
    case CURSORSTYLESET:
         getnumquery("High (0-15) ",&cursorCH,0,15);
         getnumquery("Low (0-15) ",&cursorCL,0,15);
         cursorstyleset(cursorCH,cursorCL);
         goto redraw;
#endif
    case REPEATKEY:             /* Set repeat count for next key */
         repeats=repeatflag=1;
         i=getnumquery("Repeat count",&repeatflag,1,0);
         if(repeatflag<=1 || i==ENTERKEY || i==MENUKEY) repeatflag=0;
         else
         if(i!=RETURNKEY){
           repeats=repeatflag+1; repeatflag=0; repkey=i;
         }
         goto newcursor;
    default: goto fourthswitch;
    }/* end switch */
    continue;

fourthswitch:
/* Character c wasn't harmless. Do next set which changes text. */
    switch(c){
    case CONTROLENTRY:                  /* Control code input */
         /* ^@ comes out as 128 below */
         c=getbyte();
#if MSDOS                   /* Handle IBM-PC function keys */
         if(c==128) {editln(c); c=getbyte();}
#endif
         c |= 256;                      /* transparent to ^H and DEL */
editor:
         editln(c);
         goto textchanged;
    case DELMANYLINES:
         getquery("Delete lines. How many? ");
         n=0;
         goto massdel;
    case QZAPKEY:                       /* del phrase match at cursor */
         if(zap(optbuf)) goto textchanged;
         goto newcursor;
    case QPOPKEY:
         if(addstring(optbuf,line[row],TRUE,insmode)>=1) fiddle=1;
         goto newcursor;
    case CHARTRANSPOSE:   /* transpose characters at cursor */
         if(chartranspose()) goto textchanged;
         goto newcursor;
    case LINETRANSPOSE:  /* transpose lines at cursor */
         linetranspose();
         goto textchanged;
    case COPYBLOCK:                     /* dup onto notepad */
         if(!markset) goto reveal1;     /* Bad region */
         setcorner();
         i=regionbanner("Copy to NotePad [N]","YN");
         if(i != 'Y') goto newcursor;
         lx = 1+getoffset();
         if(regdef==0) goto pushmanylines1;
         i=min(1+markcol-col,MAXLN-curoff-col); /* copy matrix */
         if(i<=0) goto newcursor;
         X.str=0;
         pushlines(curoff+col,i,(struct bigarray far *)&X,absLL(lx));
         goto newcursor;
    case APPENDLINE:            /* append line to NotePad */
    case OPTPUSHKEY:            /* Copy phrase to end of NotePad */
         setSYSone();           /* goto pushmanylines; */
    case APPENDLINE+WASENTER:   /* append line to NotePad */
    case PUSHKEY+WASENTER:      /* Copy line to killerlist */
pushmanylines:
          lx=getatoiLL();
pushmanylines1:
          ii = (absLL(lx)==1);
          if(ii)  strcpy(sysvv,(c==OPTPUSHKEY ? optbuf : line[row]));
          X.str=(ii ? (FARSTR)sysvv : (FARSTR)0);
          pushlines(0,0,(struct bigarray far *)&X,lx);
         if(c==APPENDLINE) eddn();
         goto newcursor;
    case MOVEBLOCK:                     /* Cut block to notepad */
         if(!markset){badregion(); goto justcurses;}
         setcorner();                   /* cursor to upper left corner */
         i=regionbanner("Move to NotePad [N]","YN");
         if(i!='Y') goto newcursor;
         lx = 1+getoffset();
movesetup:
         if(regdef==0){n=1; goto massdel1;}
movematrix:
         i=min(1+markcol-col,MAXLN-curoff-col);
         if(i<=0) goto newcursor;
         X.str=0;
         x=(int)pushlines(curoff+col,i,(struct bigarray far *)&X,lx);
         if(!x) goto newcursor;
         dozap(x,i);                    /* delete matrix from screen */
         goto markchanged;
    case PURGELIST:
         purgelist2notepad(0); break;
    case POPLIST:
          if(yanklist()) goto markchanged; goto justcurses;
    case POPKEY:                        /* print lines from killerlist */
         if(poplist(0)) goto markchanged; goto justcurses;
    case POPKEY+WASENTER:               /* Enter+print killerlist */
         sysarg=max(sysarg,1);
         goto insertlines;
    case PASTEBLOCK:                    /* print lines from NotePad */
         curses(); strinvvideo(" ");
         { char *msg[]={
           "1=Paste lines.",
           "  Inserts new rows above the",
           "  cursor line.",
           "2=Paste matrix.",
           "  Inserts new columns left of the",
           "  cursor column. Text moves right.",
           "3=Paint the last NotePad record",
           "  over text right of the cursor.",
           "",
           "The record separator is ctrl-A.",
           "Methods 1,2 cycle through records.",
           0};
           WarningMessage(msg);
         }
         banner("Pasting method [123]: ");
         switch(getupper()){
         case '1': /* Insert lines */
insertlines:
            i=0; ii=1; break;
         case '2': /* Insert matrix */
            i=1; ii=1; break;
         case '3': /* Writeover old text */
            bell();
            if(!getyesno("Confirm paste-over")) i=2;
            else {i=1; ii=0;}
            break;
         default: i=2;
         }
         closehelpsheet();
         sysarg=1;
pastelines:
         xPrint(curchar(),row,col);
         if(i!=2){
           if((lx=poplines(i,ii,sysarg,&iii,&x))>0) {
             if(ii==1){
              regdef=i;
              if(x) xc = 'P';     /* Matrix error */
                 else
              xc=regionbanner("P=Previous. Save it [N]","YNP");
              if(xc=='Y') fiddle=1;
              else {
                if(!i) massdelete(0,lx); else
                dozap((unsigned int)lx,iii);   /* delete matrix from screen */
                markset=0;
                if(xc=='P'){++sysarg; goto pastelines;}
              }
             } else fiddle=1;
           }
         }
         goto newcursor;
    case KILLNOTEPAD:
         scrapfile(0);  /* does not kill off finfo[0] */
         if(curfile==0){setfile(0); goto editnext;}
         goto newcursor;
    case SCRAPBUFFER:                   /* scrap current file, edit next */
         if(!fiddle && usedfiles()==1) goto exiteditor;
         goto scrap;
    case SAVE_NEXT:                     /* Save and edit next ctrl-KD */
         if(!fiddle){
           if(usedfiles()==1) goto exiteditor;
           goto junkfile;
         }
    case BACKUP:                        /* Save and continue ctrl-KS */
         if( (x=closef(sysfile)) == -1) goto redraw;
         if(x) {
           if(strcmp(sysfile,finfo[curfile].fname))
             corefinfo(curfile,sysfile);
           finfo[curfile].dirty=fiddle=0;
         }
         if(!x || c==BACKUP) break;
         goto junkfile;
    case SAVEASKEY:                     /* ctrl-KW save file as .... */
         if(!getfname("Enter new file name: ",sysv)) goto newcursor;
         goto backup;
    case SAVE_EXIT:                     /* Save and quit, ctrl-KX */
         if(!fiddle) goto leaveeditor;   /* Nothing to save */
         if( (x=closef(sysfile)) == -1) goto redraw;
         if(!x) break;
         finfo[curfile].dirty=fiddle=0;
         if(x==2) c=TSRKEY;             /* For forked child exit */
leaveeditor:
#if MSDOS
         if(SUSPENDexit){ /* MSDOS simulation of unix suspend */
           savefinfo(fiddle);
           runprogram(SHELL,0);           /* SHELL defined in v.h */
           goto redraw;
         }
#endif
    case BAILOUT:                       /* Quit editor ctrl-U */
         macabort();
         clrcon();
    case TSRKEY:                        /* kill process ctrl-KZ */
exiteditor: sysv[0]=EOS;
backup:
    case SAVE_NEXT+WASENTER:            /* Enter+Save and edit next ctrl-KD */
    case BACKUP+WASENTER:               /* Save and continue ctrl-KS */
    case SAVEASKEY+WASENTER:            /* ctrl-KW save file as .... */
         savefinfo(fiddle);
#if MSDOS
         if(sysv[0] == EOS) {           /* or quit without save */
           if(c==TSRKEY || c==BAILOUT || c==SAVE_EXIT){
             if(showdirty()) goto redraw; quit(1);}
           quit(2);
         }
#endif
#if BSDunix || SYS5                     /* Suspend and continue */
         if(sysv[0] == EOS) {           /* or quit without save */
           if(c==TSRKEY ) { if(showdirty()) goto redraw; quit(1); }
           if(!freeze) quit(2);
           goto redraw;
         }
#endif
         if(exists(sysv) == 0) {        /* query for over-write */
           x=closef(sysv);              /* save the file */
           if(x == -1) goto redraw;
         }
         break;
    case RELOAD:                        /* reload current file */
         if(curfile==0) goto newcursor; /* can't reload NotePad */
         if(fiddle){
           bell();
           if(!getyesno("Discard edit")) goto newcursor;
         }
         strcpy(sysv,sysfile);
         *(finfo[curfile].fname)=255;  /* stop complaint about loading twice */
         killcurfile=curfile;
         goto doload;
    case NEWLOAD:                       /* load new Untitled ctrl-KU */
loadnewfile:
         if((NN=getslot()) != -1) {
           savefinfo(fiddle);
           sysfile[0]=0;
           goto doNEWfile;
         }
         break;
    case LOAD:                          /* load new file */
         if(!getfname("Enter file to load: ",sysv)) goto newcursor;
    case LOAD+WASENTER:                 /* Enter+load new file */
doload:
         savefinfo(fiddle);
         if(sysv[0] != EOS){
           strcpy(sysfile,sysv);
           NN=getfile(sysfile);        /* might change sysfile */
           /* Beware: this is a trick */
           if(c==RELOAD) strcpy(finfo[killcurfile].fname,sysv);
           if(NN<0){
             if(NN == -1){
               char *msg[]={"Too many files, can't open","",0};
               msg[1]=sysfile;
               WarningMessage(msg);
             }
             else if(NN == -2) {
               char *msg[]={"Can't open","",0};
               msg[1]=sysfile;
               WarningMessage(msg);
               if(getyesno("New File")
                  && sysfile[0] && (NN=getslot()) != -1) goto doNEWfile;
             } else if(NN == -3) {
               if(newedit(nextfile(sysarg)) != -1) goto editnext;
             }
             copydefaultfile();
             goto newcursor;
           }
           else {
doNEWfile:   if(!corefinfo(NN,sysfile[0] ? sysfile : UNTITLED) ||
                newedit(NN) != -1) {
                  getfinfo(&fiddle); startup();
                  convertall(NN);
                  reportfilekind();
                  if(c==RELOAD){
                     lx=finfo[killcurfile].linec;
                     col=finfo[killcurfile].colc;
                     scrapfile(killcurfile); /* don't kill notepad! */
                     goto gotokey1;
                  }
                  if(doGOTO){
                    strcpy(sysv,doGOTO);
                    doGOTO=0; goto gotokey;
                  }
                }
             else goto copyname;
           }
           goto newcursor;
copyname:
           copydefaultfile();
           goto redraw;
         }
scrap:
         if(fiddle){
           bell();
           if(!getyesno("Discard edit")) goto newcursor;
         }
junkfile:
         scrapfile(curfile);            /* won't kill notepad */
         i=nextfile(curfile+1);         /* usually don't edit NotePad */
         setfile(i ? i : nextfile(curfile-1));
editnext:
         lbuf=bufbase-1; hbuf=ebuf;
         UnPackScreenBuffer(row);
         getfinfo(&fiddle);
         goto redraw;
nextbuffer:
         i=nextfile(curfile+sysarg);
setnextbuffer:
         savefinfo(fiddle);
         if(i!=curfile && newedit(i) != -1) goto editnext;
         goto newcursor;
    case INJECT:                        /* Inject file at cursor */
         if(!getfname("Enter file to inject: ",sysvv)) goto newcursor;
    case INJECT+WASENTER:               /* Enter+Inject file at cursor*/
         if(inject(sysvv)<0) {
           bellpressany("Inject Failed");
           goto newcursor;
         }
         reportfilekind();
         goto markchanged;
    case EXTENDEDCHAR:                  /* Change prev to extended char */
         if(col>0){
           xc=curchar()[-1];
           xc ^= 128;                     /* Add or subtract 128-bit */
           goto changeforeign;
         }
         goto newcursor;
    case FOREIGNKEY:
         if(col>0 && (xc = foreign(curchar()[-1]))!=0){
changeforeign:
           i=insmode; insmode=0;        /* insert off */
           edleft(); curses();
           editln(xc);  /* replace with foreign char extended char set */
           insmode=i;
           fiddle=1;
         }
         goto newcursor;
    case RUNPROGRAM:                    /* fork to system command processor */
         runprogram(SHELL,0);           /* SHELL defined in v.h */
         goto redraw;
    case READPIPE:
    case RUNBACKGROUND:                 /* Run background, no re-entry prompt */
    case RUNMYPROGRAM:                  /* fork system program or batch file */
         getquery("Enter system command: ");
         if(!sysv[0]) goto newcursor;
#if SYS5 || BSDunix
         if(c==READPIPE){
           readpipe(sysv);
           goto redraw;
         }
#endif
    case RUNBACKGROUND+WASENTER:
    case RUNMYPROGRAM+WASENTER:
    case RUNPROGRAM+WASENTER:
         /* clearscreen(); */
         runprogram(sysv,c==RUNMYPROGRAM ? 1 : 0);
         goto redraw;
    case DSKFILES:                      /* print directory */
         getquery("Enter filespec: ");
         curses();
         if(sysv[0] && freespace()){
           banner(sysv); fiddle=1; markset=0; goto justcurses;
         }

         goto newcursor;
    case -1:
    case NULLKEY:
    case 0: break;
    default: goto extras;
    }
    continue;
markchanged: markset=0;                          /* mark changed */
textchanged: fiddle=1;                           /* text changed */
newcursor:   lcount(); continue;                 /* update status line */
justcurses:  curses(); continue;                 /* just put cursor back*/
redraw:      killstatus(); drawall(); continue;  /* redraw whole screen */

extras:
#if PIINILOAD || PIHELPDOC || PIHELPEXE
    switch(c){
#if PIHELPDOC || PIHELPEXE
    case HELPBROWSER:
               { char *msg[]={
                 "Set the browser default in",
#if MSDOS
                 "in PI.SET, e.g.,",
                 " browser=iexplore",
                 " browser=netscape",
#else
                 "in .pirc, e.g.,",
                 " browser=lynx",
                 " browser=netscape &",
#endif
                 0};
                 WarningMessage(msg);
               }
           bell();
           strcpy(sysv,BROWSER);
           if(ggetstr("Program name:",sysv)==RETURNKEY){
             if(strcmp(sysv,BROWSER)!=0)
               safecore(&BROWSER,sysv);
           }
           goto redraw;
#if MSDOS
    case HELPHTML:
           ssprintf(sysvv,"start %s %s",BROWSER,SRCDIR);
           addslash(sysvv);
           strcat(sysvv,"pihelp.htm");
           runprogram(sysvv,0); goto redraw;
#else
    case HELPHTML:
           ssprintf(sysvv,"%s %s",BROWSER,SRCDIR);
           if((p=strchr(sysvv,'&'))!=0) p[0]=' ';
           addslash(sysvv);
           strcat(sysvv,"pihelp.htm");
           if(p) strcat(sysvv," &");
runp:
           runprogram(sysvv,0); goto redraw;
    case RUNBHELP:
           if(isXwindows()) strcpy(sysvv,"xterm -geometry 80x25 -e ");
           else sysvv[0]=0;
           strcat(sysvv,SRCDIR); addslash(sysvv);
           strcat(sysvv,"pihelpbu");
           if(isXwindows()) strcat(sysvv,"&");
           goto runp;
#endif
#endif
#if PIINILOAD
    case MACROLIBRARY:
         HelpKeys(&c);
         if(c==MACROLIBRARY) c=NULLKEY;
         goto popupmenu;
    case KEYSLOADUP:
         readkeymap();
         goto newcursor;
    case DISPLAYMACRO:
         pimacrodump();
         goto newcursor;
    case DUMPKEYS:
         pidumpkey();
         goto newcursor;
    case SHRINKWINDOW:
         shrinkwindow();
         goto newcursor;
#if BSDunix || SYS5
    case NEWWINSIZE:
winupdate:
         resetWinSize(&ii,&iii);
         setwindowsize(ii,iii);
         goto newcursor;
    case SETEMACSMODE:  setEmacs(); goto newcursor;
    case SETWDSTARMODE: setWdstar(); goto newcursor;
    case SETWDPERFMODE: setWdperf(); goto newcursor;
#endif

#endif
#if PIHELPEXE
    case RUNHELP:                       /* run help program */
         { extern char *PIHLP;
           runWinprogram(PIHLP); goto redraw;
         }
    case RUNBHELP:
           runWinprogram("pihelpb"); goto redraw;
    case SETPRINTER:
         printsetup(); goto newcursor;
    case PRINTFILE:

         if(getyesno("Format for printer")){
           if(fiddle && curfile){
             pressany("Save the file first.");
             goto newcursor;
           }
           if(curfile && strcmp(sysfile,UNTITLED)){ /* can't change notepad */
             if(corefinfo(curfile,UNTITLED)) strcpy(sysfile,UNTITLED);
           }
           printformat();
           fiddle=1;
         }
         strcpy(sysv,"prn");
         ssprintf(sysvv,"Send to printer %s",sysv);
         if(getyesno(sysvv)) goto backup;
         goto justcurses;
#endif
#if PIHELPDOC
    case RUNHELP:                       /* run help program */
         clearscreen();
         help(c-RUNBHELP);
         goto redraw;
    case SETPRINTER:
         printsetup(); goto newcursor;
    case PRINTFILE:
{

         if(getyesno("Format for printer")){
           if(fiddle && curfile){
             pressany("Save the file first.");
             goto newcursor;
           }
           if(curfile && strcmp(sysfile,UNTITLED)){ /* can't change notepad */
             if(corefinfo(curfile,UNTITLED)) strcpy(sysfile,UNTITLED);
           }
           printformat();
           fiddle=1;
         }
         strcpy(sysv,"Send to default printer");
         if(!getyesno(sysv)) goto justcurses;
         ssprintf(sysvv,"/tmp/%s",ffname(sysfile));
         maketempfilename(sysvv);
         i=closef(sysvv);              /* save the file */
         { char *p; extern char *SRCDIR; extern char *getenv();
           if(i != -1){   /* it worked */
             p=getenv("HOME");
             if(p!=(char *)0) {strcpy(sysv,p); addslash(sysv);} else sysv[0]=0;
             strcat(sysv,".printfilter");
             if(classify(sysv)!=1){
               ssprintf(sysv,"%sprintfilter",SRCDIR);
             }
             strcat(sysv," "); strcat(sysv,sysvv);
             system(sysv);
             unlink(sysvv);
           }
         }
         goto justcurses;
}
#endif

    } /* end switch(c) on reform, iniload, help */
#endif

  } /* end while(TRUE) */
} /* end main() */

/* This code can be used to perform simple timing tests */
/* Usage: timer(0) sets timer, timer(1) displays elapsed time. */
#if 0
#if MSDOS
timer(n)
int n;
{
static long m; int k1,k2;
char tmp[128]; long clock();
char *endof();
if(n==0){
m = clock();
} else {
m = clock() - m;
 k1=m/100; k2=m%100;
 ssprintf(tmp,"Elapsed time = %u and %u/100 seconds",k1,k2);
 pressany(tmp);
}
}

GETtime(time) unsigned time[2];
{
void __int__();
_AX=0x2c00; __int__(0x21); time[1]= _CX; time[0]= _DX;
}

long clock(){ long x; unsigned time[2];
  GETtime(time);
  x=time[0]/256+60*(time[1]&255) + (time[1]/256)*3600L;
  x=100*x+(time[0]&255);
  return x;
}
#endif

#if BSDunix || SYS5
#include <time.h>
timer(n)
int n;
{
static long m;
char tmp[128];

if(n==0){
m = clock();
} else {
m = clock() - m;
#define FACTOR 1000000L
sprintf(tmp,"Elapsed time = %ld.%ld sec",
m/FACTOR,m%FACTOR);
#undef FACTOR
pressany(tmp);
}
}
#endif

#endif


#if 0
showmemarray(){
 int i,j;
 char far *x;
 char s[128];
#define FP_OFF(fp)      ((unsigned)(fp))
#define FP_SEG(fp)      ((unsigned)((unsigned long)(fp) >> 16))
  for(i=0;i<MAXBLOCK;++i) {
    j=memmark[i];
    if(j){
       x=(char far *)getmemblock(i);
       ssprintf(s,"Block %u: %u.%u",i,FP_SEG(x),FP_OFF(x));
       getyesno(s);
    }
  }
}
#endif
